// Fichiers Include ncessaires
#include <WinDef.h>
#include <Winbase.h>
#include <Structapi.h>

// Charge la classe Structure
set procedure to '&_dbwinhome.samples\structure.prg' additive

// Prototype de la fonction GetVersionEx tel qu'il est libell dans Win32api.prg
extern BOOL        GetVersionEx( LPSTRUCTURE ) kernel32 ;
						 from "GetVersionExA"


local  OSVERSIONINFO, dwPlatformId

// Cre l'objet structure
OSVERSIONINFO = new _OSVERSIONINFO( )

// Appele la fonction GetVersionEx en passant le paramtre OSVERSIONINFO.value,
// qui represente le contenu de la structure en mmoire
GetVersionEx( OSVERSIONINFO.value )

// Affiche le contenu des membres de la structure
? 'Major Version', OSVERSIONINFO.getMember( 'dwMajorVersion' )
? 'Minor Version', OSVERSIONINFO.getMember( 'dwMinorVersion' )
? 'Build Number', LOWORD( OSVERSIONINFO.getMember( 'dwBuildNumber' ))
dwPlatformId = OSVERSIONINFO.getMember( 'dwPlatformId' )

do case
	case dwPlatformId == VER_PLATFORM_WIN32s	
		? 'Win32s on Win 3.1'
	case dwPlatformId == VER_PLATFORM_WIN32_WINDOWS
		? 'Win32 on Windows 95'
	case dwPlatformId == VER_PLATFORM_WIN32_NT
		? 'Win32 on Windows NT'
endcase

// Cette dfinition de classe correspond  la dfinition de la structure C
// de type _OSVERSIONINFO. La fonction addMember cre les membres de la structure,
// en utilisant le Type et le Nom du champ.
class _OSVERSIONINFO of Structure
	super::addMember( TYPE_DWORD,   "dwOSVersionInfoSize" )
	super::addMember( TYPE_DWORD,   "dwMajorVersion" )
	super::addMember( TYPE_DWORD,   "dwMinorVersion" )
	super::addMember( TYPE_DWORD,   "dwBuildNumber" )
	super::addMember( TYPE_DWORD,   "dwPlatformId" )
   super::addMember( TYPE_STRING,  "szCSDVersion", 128 )

   // Cette ligne permet de renseigner le premier membre de la structure, qui
   // doit, comme prcis dans l'aide API 32, contenir la taille de la structure. 
   // la mthode length() de la classe Structure permet d'obtenir sa taille 
   // totale exprime en octets. Ainsi, lors de la cration de l'objet  partir
   // de la classe _OSVERSIONINFO, ce membre sera automatiquement initialis.
   super::setMember( "dwOSVersionInfoSize", this.length( ))
endclass


