class NameContainer(parentObj) of CONTAINER(parentObj) custom
   with (this)
      left = 3
      top = 2
      width = 55
      height = 3
      metric = 0 // Chars
      borderStyle = 3  // None
   endwith

   this.TEXT1 = new TEXT(this)
   with (this.TEXT1)
      height = 1
      left = 0.85
      top = 0.3636
      width = 14.8571
      alignVertical = 1 // Middle
      text = "Last name"
      pageno = 0
   endwith

   this.EFLASTNAME = new NameENTRYFIELD(this)
   with (this.EFLASTNAME)
      left = 0.85
      top = 1.3182
      onChange = class::GoIntoEditMode
   endwith

   this.TEXT2 = new TEXT(this)
   with (this.TEXT2)
      height = 1
      left = 25.2857
      top = 0.3636
      width = 14
      alignVertical = 1 // Middle
      text = "First name(s)"
      pageno = 0
   endwith

   this.EFFIRSTNAME = new NameENTRYFIELD(this)
   with (this.EFFIRSTNAME)
      left = 25.2857
      top = 1.3182
      onChange = class::GoIntoEditMode
   endwith

   function onOpen
     if type('this.rowset') # 'O'
       // If the Name field is in a rowset other than Form.rowset, then
       // the container's custom Rowset property should be assigned in
       // the form's onOpen event.
       //
       // If the custom property does not exist at this point, we
       // assume that Form.rowset contains our "datalink":
       this.rowset = form.rowset
     endif
     this.ExtractFirstAndLastNames()
     // Create 2 custom properties, to make it easy to reference the
     // entryfields in the rowset event handlers:
     this.rowset.efLastName  = this.efLastName
     this.rowset.efFirstName = this.efFirstName
     this.rowset.onSave := class::SaveFirstnameAndLastnameToName
     this.rowset.onNavigate := class::ExtractFirstAndLastNames
     this.rowset.onAppend   := class::ExtractFirstAndLastNames
   return

   function ExtractFirstAndLastNames
     //
     // The Name,C,25 field is formatted (for example) as "Smith, John".
     // In our forms, we split the name into efFirstName and
     // efLastName nondatalinked entryfields.
     //
     // Set up the values for the two entryfields:
     local nCommaPosition, cName
     if this.className == 'ROWSET'
       // We're in the rowset's onNavigate event, so THIS is the rowset.
       cName = this.fields['Name'].value
     else
      
// THIS is the container
       cName = this.rowset.fields['Name'].value
     endif
     if cName == null
       this.efFirstName.value := ''
       this.efLastName.value  := ''
       return
     endif
     nCommaPosition = at(',',cName)
     if nCommaPosition == 0
       this.efFirstName.value := ''
       this.efLastName.value  := cName
     else
       this.efFirstName.value := subs(cName,nCommaPosition+2)
       this.efLastName.value  := left(cName,nCommaPosition-1)
     endif
   return

   function SaveFirstnameAndLastnameToName
     // The opposite of ExtractFirstAndLastNames().
     // This method will become the rowset's onSave event handler.
     // THIS is a rowset
     this.fields['Name'].value := ;
          properName( trim(this.efLastName.value) + ', ' + ;
                      this.efFirstName.value )
     this.save()
   return

   function GoIntoEditMode
     // This is the onChange for the Name entryfields.
     // The purpose here is to ensure that the rowset is in Edit mode.
     this.parent.rowset.fields['Name'].value += ''
   return

endclass
****************************************
Class NameEntryField(parentObj) of ENTRYFIELD(parentObj) custom
   with (this)
      height = 1.2
      width = 22
      picture = "!XXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
      colorNormal = "blue/W+"
      fontSize = 14
      fontBold = false
      value = "                              "
      maxLength = 30
      pageno = 0
   endwith
endclass
*****************************************
function ProperName( cName )
   // Purpose:  Format names properly
   // Usage:  ? ProperName("MICHAEL MACLEOD")
   //     (returns "Michael MacLeod")
   // Contributing authors: Peter Rorlick, Dan Howard, Brian Kavanaugh.
   //
   local TempString, NewString, EvalChar, mCount, Separators, OldString, CapNext
   Separators = " /-'<>=*+."
   // add final space to make && routine easier to manage
   OldString = ltrim(rtrim(cName)) + " "
   NewString = ""
   TempString = ""
   CapNext = true
   for mCount = 1 to len(OldString)
     EvalChar = subs(OldString, mCount, 1)
     if EvalChar $ Separators   // end of word
       CapNext = true
       NewString += TempString + EvalChar
       TempString = ""
     elseif CapNext   // initial character of a word
       TempString = upper(EvalChar)
       CapNext = false
     else   // character w/i word
       evalchar = lower(evalchar)
       TempString += EvalChar
       if TempString = "Mc" or TempString = "Mac"
         CapNext = true
         NewString += TempString
         tempstring = ""
       endif
     endif
   next
return NewString
